/*
 * jOSEF: A Java-Based Open-Source Smart Meter Gateway Experimentation Framework
 *
 * Copyright (C) 2015 Daniel Fuchs
 * Copyright (C) 2015 Michael Hoefling
 *
 * jOSEF is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version.
 *
 * jOSEF is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Cobertura; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

package de.ekut.informatik.kn.josef.myjsml;

import org.openmuc.jsml.structures.SequenceOf;

/**
 * Representation of a SML_CosemAttrIndexList, as specified in SML v1.04.
 * 
 * @author Daniel Fuchs
 */
public class SML_CosemAttrIndexList extends SequenceOf {

    protected SML_CosemAttributeDesc[] attributeDescription;

    public SML_CosemAttributeDesc[] getAttributeDescription() {
        return attributeDescription;
    }

    public SML_CosemAttrIndexList(
            SML_CosemAttributeDesc[] attributeDescription) {
        this.attributeDescription = attributeDescription;
        seqArray = attributeDescription;
        isSelected = true;
    }

    public SML_CosemAttrIndexList() {
    }

    @Override
    protected void createElements(int length) {
        attributeDescription = new SML_CosemAttributeDesc[length];
        for (int i = 0; i < length; i++) {
            attributeDescription[i] = new SML_CosemAttributeDesc();
        }
        seqArray = attributeDescription;
    }

}
